<?php
/**
*
* @package phpBB Extension - Link bbCode
* @copyright (c) 2016 dmzx - http://www.dmzx-web.net
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

namespace dmzx\linkbbcode\migrations;

class v101 extends \phpbb\db\migration\migration
{
	static public function depends_on()
	{
		return array(
			'\dmzx\linkbbcode\migrations\update_table',
		);
	}

	public function update_data()
	{
		return array(
			array('custom', array(array($this, 'install_bbcode_for_linkbbcode'))),
		);
	}

	public function install_bbcode_for_linkbbcode()
	{
		if (!class_exists('acp_bbcodes'))
		{
			include($this->phpbb_root_path . 'includes/acp/acp_bbcodes.' . $this->php_ext);
		}
		$bbcode_tool = new \acp_bbcodes();

		$bbcode_name = 'download=';
		$bbcode_array = array(
			'bbcode_match'			=> '[download={INTTEXT1}]{INTTEXT2} {URL} {INTTEXT}[/download]',
			'bbcode_tpl'			=> '<div class="download-blocks"><dl class="extra-box download {INTTEXT1}"><dt><a href="{URL}">{INTTEXT2}</a></dt><dd>{INTTEXT}</dd></dl></div>',
			'bbcode_helpline'		=> '[download=colour]TEXT URL TEXT[/download]',
			'display_on_posting'	=> 0
		);

		$data = $bbcode_tool->build_regexp($bbcode_array['bbcode_match'], $bbcode_array['bbcode_tpl'], $bbcode_array['bbcode_helpline']);

		$bbcode_array += array(
			'bbcode_tag'			=> $data['bbcode_tag'],
			'first_pass_match'		=> $data['first_pass_match'],
			'first_pass_replace'	=> $data['first_pass_replace'],
			'second_pass_match'		=> $data['second_pass_match'],
			'second_pass_replace' 	=> $data['second_pass_replace']
		);

		$sql = 'SELECT bbcode_id
			FROM ' . $this->table_prefix . "bbcodes
			WHERE LOWER(bbcode_tag) = '" . strtolower($bbcode_name) . "'
			OR LOWER(bbcode_tag) = '" . strtolower($bbcode_array['bbcode_tag']) . "'";
		$result = $this->db->sql_query($sql);
		$row_exists = $this->db->sql_fetchrow($result);
		$this->db->sql_freeresult($result);

		if ($row_exists)
		{

		 $bbcode_id = $row_exists['bbcode_id'];

		 $sql = 'UPDATE ' . $this->table_prefix . 'bbcodes
			SET ' . $this->db->sql_build_array('UPDATE', $bbcode_array) . '
			WHERE bbcode_id = ' . $bbcode_id;
		 $this->db->sql_query($sql);
		}
		else
		{

			$sql = 'SELECT MAX(bbcode_id) AS max_bbcode_id
				FROM ' . $this->table_prefix . 'bbcodes';
			$result = $this->db->sql_query($sql);
			$row = $this->db->sql_fetchrow($result);
			$this->db->sql_freeresult($result);

			if ($row)
			{
				$bbcode_id = $row['max_bbcode_id'] + 1;

				if ($bbcode_id <= NUM_CORE_BBCODES)
				{
					$bbcode_id = NUM_CORE_BBCODES + 1;
				}
			}
			else
			{
				$bbcode_id = NUM_CORE_BBCODES + 1;
			}

			if ($bbcode_id <= BBCODE_LIMIT)
			{
				$bbcode_array['bbcode_id'] = (int) $bbcode_id;

				$this->db->sql_query('INSERT INTO ' . $this->table_prefix . 'bbcodes ' . $this->db->sql_build_array('INSERT', $bbcode_array));
			}
		}
	}
}
